#include "maxpath.h"
#include <algorithm>
#include <vector>
#include <iostream>
using namespace std;
const int MAXN=2e5+6;
bool found[MAXN];
int weight[MAXN];
int where[MAXN];
vector<int>neshta[MAXN];
int l[MAXN],r[MAXN];
struct segment_tree
{
    int tree[4*MAXN];
    void build(int l,int r,int idx)
    {
        if(l==r)
        {
            tree[idx]=weight[l];
            return;
        }
        int mid=(l+r)/2;
        build(l,mid,idx*2);
        build(mid+1,r,idx*2+1);
        tree[idx]=max(tree[idx*2],tree[idx*2+1]);
    }
    int query(int l,int r,int idx,int ql,int qr)
    {
        if(l>qr)return 0;
        if(r<ql)return 0;
        if(l>=ql&&r<=qr)return tree[idx];
        int mid=(l+r)/2;
        return max(query(l,mid,idx*2,ql,qr),query(mid+1,r,idx*2+1,ql,qr));
    }
}tr;
int n1;
void learn(int n)
{
    n1=n;
    vector<vector<int>>to_check;
    vector<pair<int,int> >lr;
    lr.push_back({1,n});
    to_check.push_back({});
    for(int i=1;i<=n;i++)to_check[0].push_back(i);
    for(;;)
    {
        if(to_check.size()==0)break;
        vector<int> v=to_check.back();
        to_check.pop_back();
        int l=lr.back().first;
        int r=lr.back().second;
        lr.pop_back();
        //cout<<"----\n";
        //for(auto xd:v)cout<<xd<<" ";
        //cout<<endl;
        if(v.size()==1)
        {
            where[v[0]]=l;
            continue;
        }
        if(v.size()==2)
        {
            int w=ask_judge(v[0],v[1]);
            weight[l]=w;
            where[v[0]]=l;
            where[v[1]]=r;
            continue;
        }
        int maxw=0;
        vector<int>left_side,right_side;
        left_side.push_back(v[0]);
        vector<pair<int,int> >neshta;
        for(int j=1;j<v.size();j++)
        {
            int w1=ask_judge(v[0],v[j]);
            neshta.push_back({w1,v[j]});
        }
        sort(neshta.rbegin(),neshta.rend());
        for(int j=0;j<neshta.size();j++)
        {
            if(neshta[j].first==neshta[0].first)
            {
                right_side.push_back(neshta[j].second);
            }
            else left_side.push_back(neshta[j].second);
        }
        int l1=l;
        int r1=l1+left_side.size()-1;
        int l2=r1+1;
        int r2=r;
        weight[r1]=neshta[0].first;
        to_check.push_back(left_side);
        lr.push_back({l1,r1});
        to_check.push_back(right_side);
        lr.push_back({l2,r2});
    }
    tr.build(1,n-1,1);
    /*for(int i=1;i<=n;i++)
    {
        cout<<i<<": "<<where[i]<<endl;
    }
    for(int i=1;i<n;i++)cout<<weight[i]<<" ";
    cout<<endl;*/
}

int ask_contestant(int a,int b)
{
    int ind1=where[a];
    int ind2=where[b];
    if(ind1>ind2)swap(ind1,ind2);
    ind2--;
    return tr.query(1,n1-1,1,ind1,ind2);
}
