#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <stack>

typedef long long llong;
const int MAXN = 10000000 + 10;
const int MOD  = 1e9 + 7;
const int INF  = 1e9;

int n, k;
int dp[MAXN];
int prefix[MAXN];
int next[MAXN];
int prev[MAXN];
int circle[MAXN];
std::stack <std::vector <bool>> left, right;
std::vector <bool> v[MAXN];
int ans;

void push(std::stack <std::vector <bool>> &st, std::vector <bool> &curr)
{
    std::vector <bool> element(k);
    for (int i = 0 ; i < k ; ++i)
    {
        element[i] = st.top()[i] && curr[i];
    }

    st.push(element);
}

bool hasBit()
{
    for (int i = 0 ; i < k ; ++i)
    {
        if (left.top()[i] && right.top()[i])
        {
            return true;
        }
    }

    return false;
}

llong power(int num, int base)
{
    if (base == 0) return 1;
    if (base  & 1) return (num * power(num, base - 1)) % MOD;
    llong res = power(num, base / 2);
    return (res * res) % MOD;
}

int inv[MAXN];
void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        inv[i] = power(i, MOD - 2);
    }

    for (int j = 0 ; j < k ; ++j)
    {
        bool isGood = true;
        for (int i = 1 ; i <= n ; ++i)
        {
            if (v[i][j] == 0)
            {
                isGood = false;
                break;
            }
        }

        if (isGood)
        {
            int ans = 1;
            for (int i = 1 ; i <= n ; ++i)
            {
                ans <<= 1;
                if (ans >= MOD) ans -= MOD;
            }

            std::cout << ans << '\n';
            return;
        }
    }

    v[0].resize(k);
    for (int i = 0 ; i < k ; ++i)
    {
        v[0][i] = 1;
    }

    left.push(v[0]);
    right.push(v[0]);

    int ptr = 1;
    for (int i = 1 ; i <= n ; ++i)
    {
        push(left, v[i]);
        while (!hasBit())
        {
            if (left.size() > 1)
            {
                left.pop();
            } else
            {
                while (right.size() > 1)
                {
                    push(left, right.top());
                    right.pop();
                }

                left.pop();
            }

            ptr++;
        }

        prev[i] = ptr;
    }

    while (!left.empty()) left.pop();
    while (!right.empty()) right.pop();

    left.push(v[0]);
    right.push(v[0]);
    ptr = n;

    for (int i = n ; i >= 1 ; --i)
    {
        push(left, v[i]);
        while (!hasBit())
        {
            if (left.size() > 1)
            {
                left.pop();
            } else
            {
                while (right.size() > 1)
                {
                    push(left, right.top());
                    right.pop();
                }

                left.pop();
            }

            ptr--;
        }

        next[i] = ptr;
    }

    while (!left.empty()) left.pop();
    while (!right.empty()) right.pop();

    left.push(v[0]);
    right.push(v[0]);
    ptr = 1;

    for (int i = n ; i >= 1 ; --i)
    {
        push(right, v[i]);
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        push(left, v[i]);
        while (ptr <= n && !hasBit())
        {
            right.pop();
            ptr++;
        }

        circle[i] = ptr;
    }

    int lastWithPrev = n;
    while (prev[lastWithPrev] > 1)
    {
        lastWithPrev--;
    }

    prefix[n + 1] = dp[n + 1] = 1;
    for (int i = n ; i >= 1 ; --i)
    {
        dp[i] = prefix[i + 1] - prefix[next[i] + 2];
        if (dp[i] < 0) dp[i] += MOD;
        prefix[i] = prefix[i + 1] + dp[i];
        if (dp[i] >= MOD) dp[i] -= MOD;
    }

    int r = n + 1;
    int res = dp[lastWithPrev + 1];
    for (int l = lastWithPrev ; l >= 1 ; --l)
    {
        while (r >= circle[l])
        {
            if (r <= n)
            {
                res = (1LL * res * inv[r - std::max(l, prev[r]) + 1]) % MOD;
            }
            r--;
        }

        ans += (1LL * res * dp[circle[l] + 1]) % MOD;
        if (ans >= MOD) ans -= MOD;

        res = (1LL * res * std::min(r, next[l]) - l + 1) % MOD;
    }

    ans += dp[1];
    if (ans >= MOD) ans -= MOD;
    std::cout << ans << '\n';
}

std::string s;
void input()
{
    std::cin >> n >> k;
    for (int i = 1 ; i <= n ; ++i)
    {
        v[i].resize(k);
        std::cin >> s;

        for (int j = 0 ; j < k ; ++j)
        {
            v[i][j] = s[j] - '0';
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}
