#include "maxpath.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <stack>

typedef long long llong;
const int MAXN = 200000 + 10;
const int MOD  = 1e9 + 7;
const int INF  = 1e9;

int n;
int num[MAXN];
inline int getRand(int to)
{
    return (rand() << 16 + rand()) % to;
}

void find(std::vector <int> nodes)
{
    if (nodes.size() == 1)
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            if (nodes[0] == i)
            {
                num[i] = 1;
            } else
            {
                num[i] = ask_judge(nodes[0], i);
            }
        }

        return;
    }

    std::vector <int> newV;
    int newRoot = nodes[getRand(nodes.size())];

    int currMin = n;
    for (const int &i : nodes)
    {
        int res = ask_judge(newRoot, i);
        if (res < currMin)
        {
            currMin = res;
            newV.clear();
        }

        if (res == currMin)
        {
            newV.push_back(res);
        }
    }

    find(newV);
}

void learn(int N)
{
    n = N;
    srand(69);
    std::vector <int> v(n);
    for (int i = 1 ; i <= n ; ++i)
    {
        v[i - 1] = i;
    }

    find(v);
}

int ask_contestant(int u, int v)
{
    return std::max(num[u], num[v]);
}
/**
4 4
1010
1001
0010
0110
*/
