// #include "maxpath.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <stack>

typedef long long llong;
const int MAXLOG = 20;
const int MAXN = 200000 + 10;
const int MOD  = 1e9 + 7;
const int INF  = 1e9;

int n;
struct Sparse
{
    int sparse[MAXLOG][MAXN];
    int getLog[MAXN];

    void build(std::vector <int> v)
    {
        for (int i = 1 ; i <= n - 1 ; ++i)
        {
            sparse[0][i] = v[i - 1];
        }

        for (int log = 1 ; (1 << log) <= n ; ++log)
        {
            for (int i = 1 ; i + (1 << log) - 1 <= n ; ++i)
            {
                sparse[log][i] = std::max(sparse[log - 1][i], sparse[log - 1][sparse[log - 1][i]]);
            }
        }

        for (int i = 1 ; i <= n ; ++i)
        {
            getLog[i] = getLog[i - 1];
            if ((1 << getLog[i] + 1) < i) getLog[i]++;
        }
    }

    int query(int l, int r)
    {
        int log = getLog[r - l + 1];
        return std::max(sparse[log][l], sparse[log][r - (1 << log) + 1]);
    }
};

Sparse sparse;
void learn(int N)
{
    n = N;
    srand(69);
    std::vector <int> v;
    for (int i = 1 ; i < n ; ++i)
    {
        v.push_back(ask_judge(i, i + 1));
    }

    sparse.build(v);
}

int ask_contestant(int u, int v)
{
    return sparse.query(std::min(u, v), std::max(u, v) - 1);
}
/**
4 4
1010
1001
0010
0110
*/
