// kruskal kur

#include "maxpath.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>

typedef long long llong;
const int MAXLOG = 20;
const int MAXN = 200000 + 10;
const int MOD  = 1e9 + 7;
const int INF  = 1e9;

int n;
struct Sparse
{
    int sparse[MAXLOG][MAXN];
    int getLog[MAXN];

    void build(std::vector <int> v)
    {
        for (int i = 0 ; i < n - 1 ; ++i)
        {
            sparse[0][i] = v[i];
        }

        for (int log = 1 ; (1 << log) < n - 1 ; ++log)
        {
            for (int i = 0 ; i + (1 << log) - 1 < n - 1 ; ++i)
            {
                sparse[log][i] = std::max(sparse[log - 1][i], sparse[log - 1][i + (1 << log - 1)]);
            }
        }

        for (int i = 1 ; i <= n ; ++i)
        {
            getLog[i] = getLog[i - 1];
            if ((1 << getLog[i] + 1) < i) getLog[i]++;
        }
    }

    int query(int l, int r)
    {
        int log = getLog[r - l + 1];
        return std::max(sparse[log][l], sparse[log][r - (1 << log) + 1]);
    }
};

Sparse sparse;
std::vector <int> v;
bool is[MAXN];
int in[MAXN];

void solve(std::vector <int> nodes)
{
    if (nodes.size() == 1)
    {
        in[nodes[0]] = v.size();
        return;
    }

    int maxEdge = -1;
    std::vector <int> onPath;
    std::vector <int> notOnPath;
    for (int i = 1 ; i < nodes.size() ; ++i)
    {
        int res = ask_judge(nodes[0], nodes[i]);
        if (res > maxEdge)
        {
            onPath.clear();
            maxEdge = res;
        }

        if (res == maxEdge)
        {
            onPath.push_back(nodes[i]);
        }
    }

    for (const int &i : onPath)
    {
        is[i] = true;
    }

    for (const int &i : nodes)
    {
        if (!is[i]) notOnPath.push_back(i);
    }

    for (const int &i : onPath)
    {
        is[i] = false;
    }

    assert(onPath.size());
    assert(notOnPath.size());

    solve(notOnPath);
    v.push_back(maxEdge);
    solve(onPath);
}

void learn(int N)
{
    n = N;
    srand(69);
    std::vector <int> nodes;
    for (int i = 1 ; i <= n ; ++i)
    {
        nodes.push_back(i);
    }

    solve(nodes);
    sparse.build(v);
}

int ask_contestant(int u, int v)
{
    return sparse.query(std::min(in[u], in[v]), std::max(in[u], in[v]) - 1);
}
/**
4 4
1010
1001
0010
0110
*/
