#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <stack>
#define int long long

typedef long long llong;
const int MAXN = 2000 + 10;
const int MOD  = 1e9 + 7;
const int INF  = 1e9;

int n, k;
int dp[MAXN][MAXN];
bool bl[MAXN][MAXN];
int prefix[MAXN][MAXN];
int next[MAXN];
int prev[MAXN];
int circle[MAXN];
std::stack <std::vector <bool>> left, right, right2;
std::vector <bool> v[MAXN];
int ans;

void push(std::stack <std::vector <bool>> &st, std::vector <bool> &curr, bool pushTo)
{
    if (pushTo) right2.push(curr);
    std::vector <bool> element(k);
    for (int i = 0 ; i < k ; ++i)
    {
        element[i] = st.top()[i] && curr[i];
    }

    st.push(element);
}

bool hasBit()
{
    for (int i = 0 ; i < k ; ++i)
    {
        if (left.top()[i] && right.top()[i])
        {
            return true;
        }
    }

    return false;
}

void solve()
{
    for (int j = 0 ; j < k ; ++j)
    {
        bool isGood = true;
        for (int i = 1 ; i <= n ; ++i)
        {
            if (v[i][j] == 0)
            {
                isGood = false;
                break;
            }
        }

        if (isGood)
        {
            int ans = 1;
            for (int i = 1 ; i <= n ; ++i)
            {
                ans <<= 1;
                if (ans >= MOD) ans -= MOD;
            }

            ans--;
            if (ans == -1) ans += MOD;
            std::cout << ans << '\n';
            return;
        }
    }

    v[0].resize(k);
    for (int i = 0 ; i < k ; ++i)
    {
        v[0][i] = 1;
    }

    left.push(v[0]);
    right.push(v[0]);

    int ptr = 1;
    for (int i = 1 ; i <= n ; ++i)
    {
        push(right, v[i], true);
        /*std::cout << "tops: " << i << ' ' << ptr << '\n';
        for (int i = 0 ; i < k ; ++i)
        {
            std::cout << left.top()[i];
        }

        std::cout << '\n';
        for (int i = 0 ; i < k ; ++i)
        {
            std::cout << right.top()[i];
        }

        std::cout << '\n';*/
        while (!hasBit())
        {
            if (left.size() > 1)
            {
                left.pop();
            } else
            {
                while (right.size() > 1)
                {
                    /*std::cout << "pop push\n";
                    for (int i = 0 ; i < k ; ++i)
                    {
                        std::cout << right2.top()[i];
                    }

                    std::cout << '\n';*/
                    push(left, right2.top(), false);
                    right.pop();
                    right2.pop();
                }

                left.pop();
            }

            ptr++;
            /*std::cout << "pop: " << i << ' ' << ptr << '\n';
            for (int i = 0 ; i < k ; ++i)
            {
                std::cout << left.top()[i];
            }

            std::cout << '\n';
            for (int i = 0 ; i < k ; ++i)
            {
                std::cout << right.top()[i];
            }

            std::cout << '\n';*/
        }

        prev[i] = ptr;
    }

    while (!left.empty()) left.pop();
    while (!right.empty()) right.pop();
    while (!right2.empty()) right2.pop();

    left.push(v[0]);
    right.push(v[0]);
    ptr = n;

    for (int i = n ; i >= 1 ; --i)
    {
        push(right, v[i], true);
        while (!hasBit())
        {
            if (left.size() > 1)
            {
                left.pop();
            } else
            {
                while (right.size() > 1)
                {
                    push(left, right2.top(), false);
                    right.pop();
                    right2.pop();
                }

                left.pop();
            }

            ptr--;
        }

        next[i] = ptr;
    }

    while (!left.empty()) left.pop();
    while (!right.empty()) right.pop();

    left.push(v[0]);
    right.push(v[0]);
    ptr = 1;

    for (int i = n ; i >= 1 ; --i)
    {
        push(right, v[i], false);
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        push(left, v[i], false);
        while (ptr <= n && !hasBit())
        {
            right.pop();
            ptr++;
        }

        circle[i] = ptr;
    }

    for (int first = 1 ; first <= n ; ++first)
    {
        prefix[n + 1][first] = 1;
        for (int pos = n ; pos >= 1 ; --pos)
        {
            if (next[pos] == n)
            {
                dp[pos][first]++;
                if (circle[first] <= pos)
                {
                    dp[pos][first]++;
                }
            }

            dp[pos][first] += prefix[pos + 1][first] - prefix[std::min(n + 1, next[pos] + 2)][first];
            if (dp[pos][first] < 0) dp[pos][first] += MOD;
            prefix[pos][first] = prefix[pos + 1][first] + dp[pos][first];
            if (prefix[pos][first] >= MOD) prefix[pos][first] -= MOD;
        }
    }

    int ans = 0;
    for (int i = 1 ; i <= n ; ++i)
    {
        if (prev[i] > 1)
        {
            break;
        }

        ans += dp[i + 1][i];
        if (ans >= MOD) ans -= MOD;
    }

    std::cout << ans << '\n';
}

std::string s;
void input()
{
    std::cin >> n >> k;
    for (int i = 1 ; i <= n ; ++i)
    {
        v[i].resize(k);
        std::cin >> s;

        for (int j = 0 ; j < k ; ++j)
        {
            v[i][j] = s[j] - '0';
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

signed main()
{
    fastIO();
    input();
    solve();

    return 0;
}

/**
4 4
1010
1001
0010
0110
*/
