#include <algorithm>
#include <iostream>
#include <numeric>
#include <limits.h>
#include <vector>
#include <stack>
#define int long long

#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")

typedef long long llong;
const int MAXN = 1000000 + 10;
const int MOD  = 1e9 + 7;
const int INF  = 1e9;

int n, k;
int lenV;
int dp[MAXN];
int prefix[MAXN];
int next[MAXN];
int prev[MAXN];
int circle[MAXN];
std::stack <std::vector <unsigned long long>> left, right, right2;
std::vector <unsigned long long> v[MAXN];
int ans;

void push(std::stack <std::vector <unsigned long long>> &st, std::vector <unsigned long long> &curr, bool pushTo)
{
    if (pushTo) right2.push(curr);
    std::vector <unsigned long long> element(lenV);
    for (int i = 0 ; i < lenV ; ++i)
    {
        element[i] = st.top()[i] & curr[i];
    }

    st.push(element);
}

bool hasBit()
{
    for (int i = 0 ; i < lenV ; ++i)
    {
        if (left.top()[i] & right.top()[i])
        {
            return true;
        }
    }

    return false;
}

void solve()
{
    for (int j = 0 ; j < k ; ++j)
    {
        bool isGood = true;
        for (int i = 1 ; i <= n ; ++i)
        {
            if (!(v[i][j / 64] & (1LL << (j % 64))))
            {
                isGood = false;
                break;
            }
        }

        if (isGood)
        {
            int ans = 1;
            for (int i = 1 ; i <= n ; ++i)
            {
                ans *= 2;
                if (ans >= MOD) ans -= MOD;
            }

            ans -= n;
            if (ans < 0) ans += MOD;
            std::cout << ans << '\n';
            return;
        }
    }

    v[0].resize(lenV);
    for (int i = 0 ; i < lenV ; ++i)
    {
        v[0][i] = -1;
    }

    left.push(v[0]);
    right.push(v[0]);

    int ptr = 1;
    for (int i = 1 ; i <= n ; ++i)
    {
        push(right, v[i], true);
        while (!hasBit())
        {
            if (left.size() > 1)
            {
                left.pop();
            } else
            {
                while (right.size() > 1)
                {
                    push(left, right2.top(), false);
                    right.pop();
                    right2.pop();
                }

                left.pop();
            }

            ptr++;
        }

        prev[i] = ptr;
    }

    while (!left.empty()) left.pop();
    while (!right.empty()) right.pop();
    while (!right2.empty()) right2.pop();

    left.push(v[0]);
    right.push(v[0]);
    ptr = n;

    for (int i = n ; i >= 1 ; --i)
    {
        push(right, v[i], true);
        while (!hasBit())
        {
            if (left.size() > 1)
            {
                left.pop();
            } else
            {
                while (right.size() > 1)
                {
                    push(left, right2.top(), false);
                    right.pop();
                    right2.pop();
                }

                left.pop();
            }

            ptr--;
        }

        next[i] = ptr;
    }

    while (!left.empty()) left.pop();
    while (!right.empty()) right.pop();

    left.push(v[0]);
    right.push(v[0]);
    ptr = 1;

    for (int i = n ; i >= 1 ; --i)
    {
        push(right, v[i], false);
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        push(left, v[i], false);
        while (ptr <= n && !hasBit())
        {
            right.pop();
            ptr++;
        }

        circle[i] = ptr;
    }

    int ans = 0, lastIdx = 0;
    for (int first = 1 ; first <= n ; ++first)
    {
        if (prev[first] > 1)
        {
            break;
        }

        if (first > 1 && circle[first] == circle[first - 1])
        {
            ans += dp[first + 1];
            if (ans >= MOD)
            {
                ans -= MOD;
            }

            continue;
        }

        prefix[n + 1] = 1;
        for (int pos = n ; pos > first ; --pos)
        {
            dp[pos] = 0;
            if (next[pos] == n)
            {
                dp[pos]++;
                if (circle[first] <= pos)
                {
                    dp[pos]++;
                }
            }

            dp[pos] += prefix[pos + 1] - prefix[std::min(n + 1, next[pos] + 2)];
            if (dp[pos] < 0) dp[pos] += MOD;
            prefix[pos] = prefix[pos + 1] + dp[pos];
            if (prefix[pos] >= MOD) prefix[pos] -= MOD;
        }

        ans += dp[first + 1];
        if (ans >= MOD) ans -= MOD;
    }

    std::cout << ans << '\n';
}

std::string s;
void input()
{
    std::cin >> n >> k; lenV = k / 64 + 1;
    for (int i = 1 ; i <= n ; ++i)
    {
        v[i].resize(lenV);
        std::cin >> s;

        for (int j = 0 ; j < k ; ++j)
        {
            v[i][j / 64] += (s[j] - '0') * (1LL << (j % 64));
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

signed main()
{
    fastIO();
    input();
    solve();

    return 0;
}

/**
4 4
1010
1001
0010
0110
*/
