///#include "Lgrader.cpp"
#include "maxpath.h"
#include <iostream>
#include <utility>
#include <random>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 200000;
const int LOG = 20;

mt19937 rg(150348);

struct group
{
    int par, edge;
    vector<int> vert;
};

int n;
int dist[2 * MAXN + 5];
int p[2 * MAXN + 5], d[2 * MAXN + 5];
vector< pair<int, int> > G[2 * MAXN + 5];
int st[2 * MAXN + 5][LOG], mx[2 * MAXN + 5][LOG];

void add_edge(int u, int v, int w)
{
    d[v] = d[u] + 1;
    st[v][0] = u;
    mx[v][0] = w;
    G[u].push_back({v, w});
    G[v].push_back({u, w});
}

int ask_judge(int a, int b);

void learn(int n0)
{
    n = n0;
    group g;
    g.par = g.edge = 0;
    g.vert.clear();
    queue<group> active;
    for (int i = 1; i <= n; ++ i)
    {
        g.vert.push_back(i);
    }
    active.push(g);

    int nv = n;
    st[n + 1][0] = n + 1;
    mx[n + 1][0] = 0;
    d[n + 1] = 0;
    while (!active.empty())
    {
        g = active.front();
        active.pop();
        int u = g.vert[rg() % g.vert.size()];
        int mx = 0;
        for (auto v : g.vert)
        {
            if (u == v) continue;
            dist[v] = ask_judge(u, v);
            mx = max(mx, dist[v]);
        }
        while (true)
        {
            int mx2 = 0;
            group g1, g2;
            g1.par = g1.edge = g2.par = g2.edge = 0;
            g1.vert.clear(); g2.vert.clear();
            g1.vert.push_back(u);
            for (auto v : g.vert)
            {
                if (u == v) continue;
                if (dist[v] == mx) g2.vert.push_back(v);
                else
                {
                    g1.vert.push_back(v);
                    mx2 = max(mx2, dist[v]);
                }
            }
            nv++;
            if (g.par != 0) add_edge(g.par, nv, g.edge);
            if (g2.vert.size() == 1) add_edge(nv, g2.vert[0], mx);
            else
            {
                g2.par = nv;
                g2.edge = mx;
                active.push(g2);
            }
            if (g1.vert.size() == 1)
            {
                add_edge(nv, g1.vert[0], mx);
                break;
            }
            else
            {
                g.par = nv;
                g.edge = mx;
                g.vert = g1.vert;
                mx = mx2;
            }
        }
    }

    for (int j = 1; j <= LOG; ++ j)
    {
        for (int i = 1; i <= nv; ++ i)
        {
            st[i][j] = st[st[i][j - 1]][j - 1];
            mx[i][j] = max(mx[i][j - 1], mx[st[i][j - 1]][j - 1]);
        }
    }
}

int LCA(int u, int v)
{
    int du = d[u], dv = d[v];
    if (du > dv)
    {
        swap(u, v);
        swap(du, dv);
    }

    int ans = 0;
    for (int j = LOG; j >= 0; -- j)
    {
        if (dv - (1ll << j) >= du)
        {
            dv -= (1ll << j);
            ans = max(ans, mx[v][j]);
            v = st[v][j];
        }
    }

    for (int j = LOG; j >= 0; -- j)
    {
        if (st[u][j] != st[v][j])
        {
            ans = max(ans, max(mx[u][j], mx[v][j]));
            u = st[u][j];
            v = st[v][j];
        }
    }

    if (u == v) return ans;
    return max(ans, mx[u][0]);
}

int ask_contestant(int a, int b)
{
    return LCA(a, b);
}
