#include <iostream>
#include <string>
#include <vector>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#define endl '\n'
using namespace std;

const int MAXN = 10000000;
const int MOD = 1000000007;

int pref[MAXN + 5];

long long modpow(long long a, long long b)
{
    long long ret = 1;
    while (b)
    {
        if (b & 1) ret = (ret * a) % MOD;
        b >>= 1;
        a = (a * a) % MOD;
    }
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, k;
    cin >> n >> k;

    vector<string> str(n + 1);
    vector< vector<int> > cnt(n + 1, vector<int>(k + 1, 0));
    for (int i = 1; i <= n; ++ i)
    {
        cin >> str[i];
        for (int j = 1; j <= k; ++ j)
        {
            cnt[i][j] = cnt[i - 1][j] + (str[i][j - 1] - '0');
        }
    }

    vector<int> opt(n + 1);
    for (int i = 1; i <= n; ++ i)
    {
        int l = opt[i - 1], r = n + 1, mid;
        while (l < r - 1)
        {
            mid = (l + r) / 2;
            bool flag = false;
            for (int j = 1; j <= k; ++ j)
            {
                if (cnt[mid][j] - cnt[i - 1][j] == mid - i + 1)
                {
                    flag = true;
                    break;
                }
            }
            if (flag) l = mid;
            else r = mid;
        }
        opt[i] = l;
    }

    if (opt[1] == n)
    {
        cout << (modpow(2, n) - n + MOD) % MOD << endl;
        return 0;
    }

    vector<int> opt2(n + 1);
    for (int i = 1; i <= n; ++ i)
    {
        int l = max(0, opt2[i - 1] - 1), r = i, mid;
        while (l < r - 1)
        {
            mid = (l + r) / 2;
            bool flag = false;
            for (int j = 1; j <= k; ++ j)
            {
                if (cnt[i][j] - cnt[mid - 1][j] == i - mid + 1)
                {
                    flag = true;
                    break;
                }
            }
            if (flag) r = mid;
            else l = mid;
        }
        opt2[i] = r;
    }

    vector<int> opt3(n + 1);
    for (int i = 1; i <= opt[1]; ++ i)
    {
        int l = max(opt3[i - 1] - 1, i), r = n + 1, mid;
        while (l < r - 1)
        {
            mid = (l + r) / 2;
            bool flag = false;
            for (int j = 1; j <= k; ++ j)
            {
                if (cnt[i][j] + cnt[n][j] - cnt[mid - 1][j] == i + n - mid + 1)
                {
                    flag = true;
                    break;
                }
            }
            if (flag) r = mid;
            else l = mid;
        }
        opt3[i] = r;
    }

    int ans = 0;
    for (int i = 1; i <= opt[1]; ++ i)
    {
        pref[i - 1] = 0;
        pref[i] = 1;
        pref[i + 1] = 2;
        for (int j = i + 2; j <= n; ++ j)
        {
            int temp = (pref[j - 1] - pref[max(opt2[j] - 2, i - 1)] + MOD) % MOD;
            pref[j] = (pref[j - 1] + temp) % MOD;
        }
        ans = (ans + (pref[n] - pref[opt3[i] - 2] + MOD) % MOD)  % MOD;
    }
    cout << ans << endl;

    return 0;
}
