#include <vector>
#include <utility>
#include <iostream>
#include <cassert>
#include "maxpath.h"
#include "maxpath.cpp"

using namespace std;

typedef long long ll;
template<class T> void check_min(T &a, const T &b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T &b){ a = (a > b) ? a : b; }
#define all(x) (x).begin(), (x).end()

const int QUERIES_LIMIT = 8e6;

vector<vector<int>> max_edge;

int n, q;
int num_queries = 0;
bool phase = false;

int ask_judge(int a, int b){
    assert(a != b);
    assert(!phase);

    ++num_queries;
    return max_edge[a][b];
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    max_edge.resize(n + 1, vector<int>(n + 1, 0));

    for(int i = 1; i <= n; ++i)
        for(int j = i + 1; j <= n; ++j){
            cin >> max_edge[i][j];
            max_edge[j][i] = max_edge[i][j];
        }

    learn(n);
    phase = true;

    if(num_queries > QUERIES_LIMIT){
        cout << "Too many queries: " << num_queries << endl;
        return 0;
    }

    cin >> q;
    for(int i = 0; i < q; ++i){
        int a, b;
        cin >> a >> b;
        assert(a != b);

        int contestant_answer = ask_contestant(a, b);
        if(contestant_answer != max_edge[a][b]){
            cout << "Wrong answer" << endl;
            return 0;
        }
    }

    cout << "Correct" << endl;
    cout << "Number of queries: " << num_queries << endl;
}
/**
3
2 2

1
3
1 2
2 3
1 3
*/
